package framework;

import flash.errors.Error;

import framework.GraphicManager;
import framework.InputManager;
import framework.SoundManager;
import framework.FontManager;

/**
 * トークン基底クラス
 * @author syun
 */
class IToken {
    public static var s_g:GraphicManager;
    public static var s_i:InputManager;
    public static var s_m:SoundManager;
    public static var s_f:FontManager;
    private var _g:GraphicManager;
    private var _i:InputManager;
    private var _m:SoundManager;
    private var _f:FontManager;

    public function new() {
        // staticメンバ変数は継承されないのでコンストラクタでコピーする
        _g = s_g;
        _i = s_i;
        _m = s_m;
        _f = s_f;
    }

    /**
     * 更新
     */
    public function update():Void {
        throw new Error("IToken.update()が未実装");
    }
    /**
     * 描画
     */
    public function draw():Void {
        throw new Error("IToken.draw()が未実装");
    }

}
